"""
exE-1.py

B(E)3M33UI - Artificial Intelligence course, FEE CTU in Prague
Decision trees and ensemble learning

Petr Posik, Jiri Spilka, CVUT, Praha 2017
"""

import numpy as np
from sklearn import cross_validation, metrics, grid_search
from sklearn.tree import DecisionTreeClassifier
from sklearn.ensemble import AdaBoostClassifier, RandomForestClassifier
from matplotlib import pyplot as plt

from mpg import load_mpg_for_classification, load_mpg_for_2D_classification
from plotting import compute_validation_curve, plot_validation_curve, plot_2D_class_model, \
    plot_xy_classified_data


def main():

    # Load data
    X, y = load_mpg_for_2D_classification()
    # X, y = load_mpg_for_classification()

    print('\nThe dataset (X and y) size:')
    print('X: ', X.shape)
    print('y: ', y.shape)
    print('sum(y = 0): ', sum(y == 0))
    print('sum(y = 1): ', sum(y == 1))

    # random_state=2017 - lets keep the training and test set the same
    Xtr, Xtst, ytr, ytst = cross_validation.train_test_split(X, y, test_size=0.2, random_state=2017)

    # FIXME Task 1: Decision Tree
    # raise NotImplementedError
    # <YOUR CODE HERE>

    # < USE TRAINING DATA ONLY >

    # FIXME Task 2: Adaboost
    # raise NotImplementedError
    # <YOUR CODE HERE>

    # FIXME Task 3: Random Forest
    # raise NotImplementedError
    # <YOUR CODE HERE>

    # FIXME Task 4-5: Classification performance on test set, decision boundary
    # raise NotImplementedError
    # <YOUR CODE HERE>

    # < USE TEST DATA FOR PREDICTIONS>

    # prediction accuracy on test set
    print('Accuracy on test data:')
    print('Decision Tree: ', metrics.accuracy_score(ytst, m1.predict(Xtst)))
    print('Adaboost: ', metrics.accuracy_score(ytst, m2.predict(Xtst)))
    print('Random forest: ', metrics.accuracy_score(ytst, m3.predict(Xtst)))

# catch all exceptions
try:
    plt.ion()  # turn interactive mode on so our plots stay open like in matlab
    main()

except BaseException as e:
    import traceback
    traceback.print_exc()  # mimic printing traceback from an exception
    plt.ioff()  # turn interactive mode off
    plt.show()  # show whatever we have to show, it will stay open because we turned interactive mode off

