"""
exE-1.py

B(E)3M33UI - Artificial Intelligence course, FEE CTU in Prague
Decision trees and ensemble models

Petr Posik, Jiri Spilka, CVUT, Praha 2017
"""

import numpy as np
from sklearn import cross_validation, metrics, grid_search
from sklearn.tree import DecisionTreeClassifier
from sklearn.ensemble import AdaBoostClassifier, RandomForestClassifier, VotingClassifier
from matplotlib import pyplot as plt

from mpg import load_mpg_for_classification, load_mpg_for_2D_classification
from plotting import compute_validation_curve, plot_validation_curve, plot_2D_class_model, \
    plot_xy_classified_data


def main():

    # Load data
    X, y = load_mpg_for_2D_classification()
    # X, y = load_mpg_for_classification()

    print('\nThe dataset (X and y) size:')
    print('X: ', X.shape)
    print('y: ', y.shape)
    print('sum(y = 0): ', sum(y == 0))
    print('sum(y = 1): ', sum(y == 1))

    # random_state=2017 - lets keep the training and test set the same
    Xtr, Xtst, ytr, ytst = cross_validation.train_test_split(X, y, test_size=0.2, random_state=2017)

    # FIXME Task 6: Model ensemble via majority voting
    m1 = DecisionTreeClassifier()
    m2 = AdaBoostClassifier()
    m3 = RandomForestClassifier()

    # raise NotImplementedError
    # <YOUR CODE HERE>

# catch all exceptions
try:
    plt.ion()  # turn interactive mode on so our plots stay open like in matlab
    main()
except BaseException as e:
    import traceback
    traceback.print_exc()  # mimic printing traceback from an exception
    plt.ioff()  # turn interactive mode off
    plt.show()  # show whatever we have to show, it will stay open because we turned interactive mode off